#include <iostream>
#include <algorithm>

using namespace std;

string dirs[] = {"top", "bottom", "left", "right"};
int vals[4];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int r, c, k;
	cin>>r>>c>>k;
	
	int minr = r, maxr = 0, minc = c, maxc = 0;
	for (int i = 0; i < k; ++i) {
		int a, b;
		cin>>a>>b;
		minr = min(minr, a);
		maxr = max(maxr, a);
		minc = min(minc, b);
		maxc = max(maxc, b);
	}
	
	vals[0] = minr - 1;
	vals[1] = r - maxr;
	vals[2] = minc - 1;
	vals[3] = c - maxc;
	
	int x = vals[0] ^ vals[1] ^ vals[2] ^ vals[3];
	if (x) {
		for (int i = 0; i < 4; ++i) if ((vals[i] ^ x) <= vals[i]) {
			cout<<dirs[i]<<' '<<vals[i] - (vals[i] ^ x)<<endl;
			vals[i] ^= x;
			break;
		}
	} else {
		cout<<"pass"<<endl;
	}

	while (true) {
		string dir;
		cin>>dir;
		if (dir == "yuck!") break;
		int d = find(dirs, dirs + 4, dir) - dirs;
		
		int v;
		cin>>v;
		
		x = vals[d] ^ (vals[d] - v);
		vals[d] -= v;
		
		for (int i = 0; i < 4; ++i) if ((vals[i] ^ x) <= vals[i]) {
			cout<<dirs[i]<<' '<<vals[i] - (vals[i] ^ x)<<endl;
			vals[i] ^= x;
			break;
		}
	}
}
